package jp.mosp.common.part;

import jp.mosp.common.common.InstanceFactory;
import jp.mosp.common.common.MospException;

/**
 * Partクラスのインスタンスを生成するクラス
 * @author yoshida
 * 	@version	0.0.1
 */
public class PartFactory {

	/**
	 * パート生成
	 * @param className		BasePartを継承した対象PartClass名称
	 * @param partInfo		インスタンスの初期化時に必要な情報DTO
	 * @return				対象PartClassのインスタンス
	 * @throws MospException
	 */
	public static BasePart create(String className, PartInfo partInfo) throws MospException {
		BasePart part = null;
		Object obj = getInstance(className);
		if (obj instanceof BasePart) {
			part = (BasePart) obj;
			part.init(partInfo);
		}
		return part;
	}

	/**
	 * クラスインスタンス取得。<br>
	 * @param className クラス名
	 * @return クラスのインスタンス
	 * @throws IllegalAccessException
	 * @throws InstantiationException
	 * @throws MosPException
	 */
	static Object getInstance(
			String className
	) throws MospException {
		return InstanceFactory.loadInstance(className);
	}

}
